package main

import (
	"fmt"
	"runtime"
)

func PrintNum(name string, intChan chan int) {
	for i := 0; i < 3; i++ {
		fmt.Println(name, ":", i)
		runtime.Gosched() // yields the processor, allowing other goroutines to run
	}
	intChan <- 1
}

func main() {
	intChan := make(chan int, 1)

	// 单示例
	go PrintNum("no1", intChan)
	go PrintNum("no2", intChan)

	<-intChan
	<-intChan

	// 批量示例
	for i := 0; i < 5; i++ {
		go PrintNum(fmt.Sprintf("no%d", i), intChan)
	}
	for i := 0; i < 5; i++ {
		<-intChan
	}
}
